# Access Rules ## List IP Access rules `client.firewall.accessRules.list(AccessRuleListParamsparams?, RequestOptionsoptions?): V4PagePaginationArray` **get** `/{accounts_or_zones}/{account_or_zone_id}/firewall/access_rules/rules` Fetches IP Access rules of an account or zone. These rules apply to all the zones in the account or zone. You can filter the results using several optional parameters. ### Parameters - `params: AccessRuleListParams` - `account_id?: string` Path param: The Account ID to use for this endpoint. Mutually exclusive with the Zone ID. - `zone_id?: string` Path param: The Zone ID to use for this endpoint. Mutually exclusive with the Account ID. - `configuration?: Configuration` Query param - `target?: "ip" | "ip_range" | "asn" | "country"` Defines the target to search in existing rules. - `"ip"` - `"ip_range"` - `"asn"` - `"country"` - `value?: string` Defines the target value to search for in existing rules: an IP address, an IP address range, or a country code, depending on the provided `configuration.target`. Notes: You can search for a single IPv4 address, an IP address range with a subnet of '/16' or '/24', or a two-letter ISO-3166-1 alpha-2 country code. - `direction?: "asc" | "desc"` Query param: Defines the direction used to sort returned rules. - `"asc"` - `"desc"` - `match?: "any" | "all"` Query param: Defines the search requirements. When set to `all`, all the search requirements must match. When set to `any`, only one of the search requirements has to match. - `"any"` - `"all"` - `mode?: "block" | "challenge" | "whitelist" | 2 more` Query param: The action to apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `notes?: string` Query param: Defines the string to search for in the notes of existing IP Access rules. Notes: For example, the string 'attack' would match IP Access rules with notes 'Attack 26/02' and 'Attack 27/02'. The search is case insensitive. - `order?: "configuration.target" | "configuration.value" | "mode"` Query param: Defines the field used to sort returned rules. - `"configuration.target"` - `"configuration.value"` - `"mode"` - `page?: number` Query param: Defines the requested page within paginated list of results. - `per_page?: number` Query param: Defines the maximum number of results requested. ### Returns - `AccessRuleListResponse` - `id: string` The unique identifier of the IP Access rule. - `allowed_modes: Array<"block" | "challenge" | "whitelist" | 2 more>` The available actions that a rule can apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `configuration: AccessRuleIPConfiguration | IPV6Configuration | AccessRuleCIDRConfiguration | 2 more` The rule configuration. - `AccessRuleIPConfiguration` - `target?: "ip"` The configuration target. You must set the target to `ip` when specifying an IP address in the rule. - `"ip"` - `value?: string` The IP address to match. This address will be compared to the IP address of incoming requests. - `IPV6Configuration` - `target?: "ip6"` The configuration target. You must set the target to `ip6` when specifying an IPv6 address in the rule. - `"ip6"` - `value?: string` The IPv6 address to match. - `AccessRuleCIDRConfiguration` - `target?: "ip_range"` The configuration target. You must set the target to `ip_range` when specifying an IP address range in the rule. - `"ip_range"` - `value?: string` The IP address range to match. You can only use prefix lengths `/16` and `/24` for IPv4 ranges, and prefix lengths `/32`, `/48`, and `/64` for IPv6 ranges. - `ASNConfiguration` - `target?: "asn"` The configuration target. You must set the target to `asn` when specifying an Autonomous System Number (ASN) in the rule. - `"asn"` - `value?: string` The AS number to match. - `CountryConfiguration` - `target?: "country"` The configuration target. You must set the target to `country` when specifying a country code in the rule. - `"country"` - `value?: string` The two-letter ISO-3166-1 alpha-2 code to match. For more information, refer to [IP Access rules: Parameters](https://developers.cloudflare.com/waf/tools/ip-access-rules/parameters/#country). - `mode: "block" | "challenge" | "whitelist" | 2 more` The action to apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `created_on?: string` The timestamp of when the rule was created. - `modified_on?: string` The timestamp of when the rule was last modified. - `notes?: string` An informative summary of the rule, typically used as a reminder or explanation. - `scope?: Scope` All zones owned by the user will have the rule applied. - `id?: string` Defines an identifier. - `email?: string` The contact email address of the user. - `type?: "user" | "organization"` Defines the scope of the rule. - `"user"` - `"organization"` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); // Automatically fetches more pages as needed. for await (const accessRuleListResponse of client.firewall.accessRules.list({ account_id: 'account_id', })) { console.log(accessRuleListResponse.id); } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": [ { "id": "92f17202ed8bd63d69a66b86a49a8f6b", "allowed_modes": [ "whitelist", "block", "challenge", "js_challenge", "managed_challenge" ], "configuration": { "target": "ip", "value": "198.51.100.4" }, "mode": "challenge", "created_on": "2014-01-01T05:20:00.12345Z", "modified_on": "2014-01-01T05:20:00.12345Z", "notes": "This rule is enabled because of an event that occurred on date X.", "scope": { "id": "023e105f4ecef8ad9ca31a8372d0c353", "email": "user@example.com", "type": "user" } } ], "success": true, "result_info": { "count": 1, "page": 1, "per_page": 20, "total_count": 2000 } } ``` ## Get an IP Access rule `client.firewall.accessRules.get(stringruleId, AccessRuleGetParamsparams?, RequestOptionsoptions?): AccessRuleGetResponse` **get** `/{accounts_or_zones}/{account_or_zone_id}/firewall/access_rules/rules/{rule_id}` Fetches the details of an IP Access rule defined. ### Parameters - `ruleId: string` Unique identifier for a rule. - `params: AccessRuleGetParams` - `account_id?: string` The Account ID to use for this endpoint. Mutually exclusive with the Zone ID. - `zone_id?: string` The Zone ID to use for this endpoint. Mutually exclusive with the Account ID. ### Returns - `AccessRuleGetResponse` - `id: string` The unique identifier of the IP Access rule. - `allowed_modes: Array<"block" | "challenge" | "whitelist" | 2 more>` The available actions that a rule can apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `configuration: AccessRuleIPConfiguration | IPV6Configuration | AccessRuleCIDRConfiguration | 2 more` The rule configuration. - `AccessRuleIPConfiguration` - `target?: "ip"` The configuration target. You must set the target to `ip` when specifying an IP address in the rule. - `"ip"` - `value?: string` The IP address to match. This address will be compared to the IP address of incoming requests. - `IPV6Configuration` - `target?: "ip6"` The configuration target. You must set the target to `ip6` when specifying an IPv6 address in the rule. - `"ip6"` - `value?: string` The IPv6 address to match. - `AccessRuleCIDRConfiguration` - `target?: "ip_range"` The configuration target. You must set the target to `ip_range` when specifying an IP address range in the rule. - `"ip_range"` - `value?: string` The IP address range to match. You can only use prefix lengths `/16` and `/24` for IPv4 ranges, and prefix lengths `/32`, `/48`, and `/64` for IPv6 ranges. - `ASNConfiguration` - `target?: "asn"` The configuration target. You must set the target to `asn` when specifying an Autonomous System Number (ASN) in the rule. - `"asn"` - `value?: string` The AS number to match. - `CountryConfiguration` - `target?: "country"` The configuration target. You must set the target to `country` when specifying a country code in the rule. - `"country"` - `value?: string` The two-letter ISO-3166-1 alpha-2 code to match. For more information, refer to [IP Access rules: Parameters](https://developers.cloudflare.com/waf/tools/ip-access-rules/parameters/#country). - `mode: "block" | "challenge" | "whitelist" | 2 more` The action to apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `created_on?: string` The timestamp of when the rule was created. - `modified_on?: string` The timestamp of when the rule was last modified. - `notes?: string` An informative summary of the rule, typically used as a reminder or explanation. - `scope?: Scope` All zones owned by the user will have the rule applied. - `id?: string` Defines an identifier. - `email?: string` The contact email address of the user. - `type?: "user" | "organization"` Defines the scope of the rule. - `"user"` - `"organization"` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const accessRule = await client.firewall.accessRules.get('023e105f4ecef8ad9ca31a8372d0c353', { account_id: 'account_id', }); console.log(accessRule.id); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "id": "92f17202ed8bd63d69a66b86a49a8f6b", "allowed_modes": [ "whitelist", "block", "challenge", "js_challenge", "managed_challenge" ], "configuration": { "target": "ip", "value": "198.51.100.4" }, "mode": "challenge", "created_on": "2014-01-01T05:20:00.12345Z", "modified_on": "2014-01-01T05:20:00.12345Z", "notes": "This rule is enabled because of an event that occurred on date X.", "scope": { "id": "023e105f4ecef8ad9ca31a8372d0c353", "email": "user@example.com", "type": "user" } }, "success": true } ``` ## Create an IP Access rule `client.firewall.accessRules.create(AccessRuleCreateParamsparams, RequestOptionsoptions?): AccessRuleCreateResponse` **post** `/{accounts_or_zones}/{account_or_zone_id}/firewall/access_rules/rules` Creates a new IP Access rule for an account or zone. The rule will apply to all zones in the account or zone. Note: To create an IP Access rule that applies to a single zone, refer to the [IP Access rules for a zone](#ip-access-rules-for-a-zone) endpoints. ### Parameters - `params: AccessRuleCreateParams` - `configuration: AccessRuleIPConfiguration | IPV6Configuration | AccessRuleCIDRConfiguration | 2 more` Body param: The rule configuration. - `AccessRuleIPConfiguration` - `target?: "ip"` The configuration target. You must set the target to `ip` when specifying an IP address in the rule. - `"ip"` - `value?: string` The IP address to match. This address will be compared to the IP address of incoming requests. - `IPV6Configuration` - `target?: "ip6"` The configuration target. You must set the target to `ip6` when specifying an IPv6 address in the rule. - `"ip6"` - `value?: string` The IPv6 address to match. - `AccessRuleCIDRConfiguration` - `target?: "ip_range"` The configuration target. You must set the target to `ip_range` when specifying an IP address range in the rule. - `"ip_range"` - `value?: string` The IP address range to match. You can only use prefix lengths `/16` and `/24` for IPv4 ranges, and prefix lengths `/32`, `/48`, and `/64` for IPv6 ranges. - `ASNConfiguration` - `target?: "asn"` The configuration target. You must set the target to `asn` when specifying an Autonomous System Number (ASN) in the rule. - `"asn"` - `value?: string` The AS number to match. - `CountryConfiguration` - `target?: "country"` The configuration target. You must set the target to `country` when specifying a country code in the rule. - `"country"` - `value?: string` The two-letter ISO-3166-1 alpha-2 code to match. For more information, refer to [IP Access rules: Parameters](https://developers.cloudflare.com/waf/tools/ip-access-rules/parameters/#country). - `mode: "block" | "challenge" | "whitelist" | 2 more` Body param: The action to apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `account_id?: string` Path param: The Account ID to use for this endpoint. Mutually exclusive with the Zone ID. - `zone_id?: string` Path param: The Zone ID to use for this endpoint. Mutually exclusive with the Account ID. - `notes?: string` Body param: An informative summary of the rule, typically used as a reminder or explanation. ### Returns - `AccessRuleCreateResponse` - `id: string` The unique identifier of the IP Access rule. - `allowed_modes: Array<"block" | "challenge" | "whitelist" | 2 more>` The available actions that a rule can apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `configuration: AccessRuleIPConfiguration | IPV6Configuration | AccessRuleCIDRConfiguration | 2 more` The rule configuration. - `AccessRuleIPConfiguration` - `target?: "ip"` The configuration target. You must set the target to `ip` when specifying an IP address in the rule. - `"ip"` - `value?: string` The IP address to match. This address will be compared to the IP address of incoming requests. - `IPV6Configuration` - `target?: "ip6"` The configuration target. You must set the target to `ip6` when specifying an IPv6 address in the rule. - `"ip6"` - `value?: string` The IPv6 address to match. - `AccessRuleCIDRConfiguration` - `target?: "ip_range"` The configuration target. You must set the target to `ip_range` when specifying an IP address range in the rule. - `"ip_range"` - `value?: string` The IP address range to match. You can only use prefix lengths `/16` and `/24` for IPv4 ranges, and prefix lengths `/32`, `/48`, and `/64` for IPv6 ranges. - `ASNConfiguration` - `target?: "asn"` The configuration target. You must set the target to `asn` when specifying an Autonomous System Number (ASN) in the rule. - `"asn"` - `value?: string` The AS number to match. - `CountryConfiguration` - `target?: "country"` The configuration target. You must set the target to `country` when specifying a country code in the rule. - `"country"` - `value?: string` The two-letter ISO-3166-1 alpha-2 code to match. For more information, refer to [IP Access rules: Parameters](https://developers.cloudflare.com/waf/tools/ip-access-rules/parameters/#country). - `mode: "block" | "challenge" | "whitelist" | 2 more` The action to apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `created_on?: string` The timestamp of when the rule was created. - `modified_on?: string` The timestamp of when the rule was last modified. - `notes?: string` An informative summary of the rule, typically used as a reminder or explanation. - `scope?: Scope` All zones owned by the user will have the rule applied. - `id?: string` Defines an identifier. - `email?: string` The contact email address of the user. - `type?: "user" | "organization"` Defines the scope of the rule. - `"user"` - `"organization"` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const accessRule = await client.firewall.accessRules.create({ configuration: {}, mode: 'challenge', account_id: 'account_id', }); console.log(accessRule.id); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "id": "92f17202ed8bd63d69a66b86a49a8f6b", "allowed_modes": [ "whitelist", "block", "challenge", "js_challenge", "managed_challenge" ], "configuration": { "target": "ip", "value": "198.51.100.4" }, "mode": "challenge", "created_on": "2014-01-01T05:20:00.12345Z", "modified_on": "2014-01-01T05:20:00.12345Z", "notes": "This rule is enabled because of an event that occurred on date X.", "scope": { "id": "023e105f4ecef8ad9ca31a8372d0c353", "email": "user@example.com", "type": "user" } }, "success": true } ``` ## Update an IP Access rule `client.firewall.accessRules.edit(stringruleId, AccessRuleEditParamsparams, RequestOptionsoptions?): AccessRuleEditResponse` **patch** `/{accounts_or_zones}/{account_or_zone_id}/firewall/access_rules/rules/{rule_id}` Updates an IP Access rule defined. Note: This operation will affect all zones in the account or zone. ### Parameters - `ruleId: string` Unique identifier for a rule. - `params: AccessRuleEditParams` - `configuration: AccessRuleIPConfiguration | IPV6Configuration | AccessRuleCIDRConfiguration | 2 more` Body param: The rule configuration. - `AccessRuleIPConfiguration` - `target?: "ip"` The configuration target. You must set the target to `ip` when specifying an IP address in the rule. - `"ip"` - `value?: string` The IP address to match. This address will be compared to the IP address of incoming requests. - `IPV6Configuration` - `target?: "ip6"` The configuration target. You must set the target to `ip6` when specifying an IPv6 address in the rule. - `"ip6"` - `value?: string` The IPv6 address to match. - `AccessRuleCIDRConfiguration` - `target?: "ip_range"` The configuration target. You must set the target to `ip_range` when specifying an IP address range in the rule. - `"ip_range"` - `value?: string` The IP address range to match. You can only use prefix lengths `/16` and `/24` for IPv4 ranges, and prefix lengths `/32`, `/48`, and `/64` for IPv6 ranges. - `ASNConfiguration` - `target?: "asn"` The configuration target. You must set the target to `asn` when specifying an Autonomous System Number (ASN) in the rule. - `"asn"` - `value?: string` The AS number to match. - `CountryConfiguration` - `target?: "country"` The configuration target. You must set the target to `country` when specifying a country code in the rule. - `"country"` - `value?: string` The two-letter ISO-3166-1 alpha-2 code to match. For more information, refer to [IP Access rules: Parameters](https://developers.cloudflare.com/waf/tools/ip-access-rules/parameters/#country). - `mode: "block" | "challenge" | "whitelist" | 2 more` Body param: The action to apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `account_id?: string` Path param: The Account ID to use for this endpoint. Mutually exclusive with the Zone ID. - `zone_id?: string` Path param: The Zone ID to use for this endpoint. Mutually exclusive with the Account ID. - `notes?: string` Body param: An informative summary of the rule, typically used as a reminder or explanation. ### Returns - `AccessRuleEditResponse` - `id: string` The unique identifier of the IP Access rule. - `allowed_modes: Array<"block" | "challenge" | "whitelist" | 2 more>` The available actions that a rule can apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `configuration: AccessRuleIPConfiguration | IPV6Configuration | AccessRuleCIDRConfiguration | 2 more` The rule configuration. - `AccessRuleIPConfiguration` - `target?: "ip"` The configuration target. You must set the target to `ip` when specifying an IP address in the rule. - `"ip"` - `value?: string` The IP address to match. This address will be compared to the IP address of incoming requests. - `IPV6Configuration` - `target?: "ip6"` The configuration target. You must set the target to `ip6` when specifying an IPv6 address in the rule. - `"ip6"` - `value?: string` The IPv6 address to match. - `AccessRuleCIDRConfiguration` - `target?: "ip_range"` The configuration target. You must set the target to `ip_range` when specifying an IP address range in the rule. - `"ip_range"` - `value?: string` The IP address range to match. You can only use prefix lengths `/16` and `/24` for IPv4 ranges, and prefix lengths `/32`, `/48`, and `/64` for IPv6 ranges. - `ASNConfiguration` - `target?: "asn"` The configuration target. You must set the target to `asn` when specifying an Autonomous System Number (ASN) in the rule. - `"asn"` - `value?: string` The AS number to match. - `CountryConfiguration` - `target?: "country"` The configuration target. You must set the target to `country` when specifying a country code in the rule. - `"country"` - `value?: string` The two-letter ISO-3166-1 alpha-2 code to match. For more information, refer to [IP Access rules: Parameters](https://developers.cloudflare.com/waf/tools/ip-access-rules/parameters/#country). - `mode: "block" | "challenge" | "whitelist" | 2 more` The action to apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `created_on?: string` The timestamp of when the rule was created. - `modified_on?: string` The timestamp of when the rule was last modified. - `notes?: string` An informative summary of the rule, typically used as a reminder or explanation. - `scope?: Scope` All zones owned by the user will have the rule applied. - `id?: string` Defines an identifier. - `email?: string` The contact email address of the user. - `type?: "user" | "organization"` Defines the scope of the rule. - `"user"` - `"organization"` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const response = await client.firewall.accessRules.edit('023e105f4ecef8ad9ca31a8372d0c353', { configuration: {}, mode: 'challenge', account_id: 'account_id', }); console.log(response.id); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "id": "92f17202ed8bd63d69a66b86a49a8f6b", "allowed_modes": [ "whitelist", "block", "challenge", "js_challenge", "managed_challenge" ], "configuration": { "target": "ip", "value": "198.51.100.4" }, "mode": "challenge", "created_on": "2014-01-01T05:20:00.12345Z", "modified_on": "2014-01-01T05:20:00.12345Z", "notes": "This rule is enabled because of an event that occurred on date X.", "scope": { "id": "023e105f4ecef8ad9ca31a8372d0c353", "email": "user@example.com", "type": "user" } }, "success": true } ``` ## Delete an IP Access rule `client.firewall.accessRules.delete(stringruleId, AccessRuleDeleteParamsparams?, RequestOptionsoptions?): AccessRuleDeleteResponse | null` **delete** `/{accounts_or_zones}/{account_or_zone_id}/firewall/access_rules/rules/{rule_id}` Deletes an existing IP Access rule defined. Note: This operation will affect all zones in the account or zone. ### Parameters - `ruleId: string` Unique identifier for a rule. - `params: AccessRuleDeleteParams` - `account_id?: string` The Account ID to use for this endpoint. Mutually exclusive with the Zone ID. - `zone_id?: string` The Zone ID to use for this endpoint. Mutually exclusive with the Account ID. ### Returns - `AccessRuleDeleteResponse` - `id: string` Defines an identifier. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const accessRule = await client.firewall.accessRules.delete('023e105f4ecef8ad9ca31a8372d0c353', { account_id: 'account_id', }); console.log(accessRule.id); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "id": "023e105f4ecef8ad9ca31a8372d0c353" }, "success": true } ``` ## Domain Types ### Access Rule CIDR Configuration - `AccessRuleCIDRConfiguration` - `target?: "ip_range"` The configuration target. You must set the target to `ip_range` when specifying an IP address range in the rule. - `"ip_range"` - `value?: string` The IP address range to match. You can only use prefix lengths `/16` and `/24` for IPv4 ranges, and prefix lengths `/32`, `/48`, and `/64` for IPv6 ranges. ### Access Rule IP Configuration - `AccessRuleIPConfiguration` - `target?: "ip"` The configuration target. You must set the target to `ip` when specifying an IP address in the rule. - `"ip"` - `value?: string` The IP address to match. This address will be compared to the IP address of incoming requests. ### ASN Configuration - `ASNConfiguration` - `target?: "asn"` The configuration target. You must set the target to `asn` when specifying an Autonomous System Number (ASN) in the rule. - `"asn"` - `value?: string` The AS number to match. ### Country Configuration - `CountryConfiguration` - `target?: "country"` The configuration target. You must set the target to `country` when specifying a country code in the rule. - `"country"` - `value?: string` The two-letter ISO-3166-1 alpha-2 code to match. For more information, refer to [IP Access rules: Parameters](https://developers.cloudflare.com/waf/tools/ip-access-rules/parameters/#country). ### IPV6 Configuration - `IPV6Configuration` - `target?: "ip6"` The configuration target. You must set the target to `ip6` when specifying an IPv6 address in the rule. - `"ip6"` - `value?: string` The IPv6 address to match. ### Access Rule List Response - `AccessRuleListResponse` - `id: string` The unique identifier of the IP Access rule. - `allowed_modes: Array<"block" | "challenge" | "whitelist" | 2 more>` The available actions that a rule can apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `configuration: AccessRuleIPConfiguration | IPV6Configuration | AccessRuleCIDRConfiguration | 2 more` The rule configuration. - `AccessRuleIPConfiguration` - `target?: "ip"` The configuration target. You must set the target to `ip` when specifying an IP address in the rule. - `"ip"` - `value?: string` The IP address to match. This address will be compared to the IP address of incoming requests. - `IPV6Configuration` - `target?: "ip6"` The configuration target. You must set the target to `ip6` when specifying an IPv6 address in the rule. - `"ip6"` - `value?: string` The IPv6 address to match. - `AccessRuleCIDRConfiguration` - `target?: "ip_range"` The configuration target. You must set the target to `ip_range` when specifying an IP address range in the rule. - `"ip_range"` - `value?: string` The IP address range to match. You can only use prefix lengths `/16` and `/24` for IPv4 ranges, and prefix lengths `/32`, `/48`, and `/64` for IPv6 ranges. - `ASNConfiguration` - `target?: "asn"` The configuration target. You must set the target to `asn` when specifying an Autonomous System Number (ASN) in the rule. - `"asn"` - `value?: string` The AS number to match. - `CountryConfiguration` - `target?: "country"` The configuration target. You must set the target to `country` when specifying a country code in the rule. - `"country"` - `value?: string` The two-letter ISO-3166-1 alpha-2 code to match. For more information, refer to [IP Access rules: Parameters](https://developers.cloudflare.com/waf/tools/ip-access-rules/parameters/#country). - `mode: "block" | "challenge" | "whitelist" | 2 more` The action to apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `created_on?: string` The timestamp of when the rule was created. - `modified_on?: string` The timestamp of when the rule was last modified. - `notes?: string` An informative summary of the rule, typically used as a reminder or explanation. - `scope?: Scope` All zones owned by the user will have the rule applied. - `id?: string` Defines an identifier. - `email?: string` The contact email address of the user. - `type?: "user" | "organization"` Defines the scope of the rule. - `"user"` - `"organization"` ### Access Rule Get Response - `AccessRuleGetResponse` - `id: string` The unique identifier of the IP Access rule. - `allowed_modes: Array<"block" | "challenge" | "whitelist" | 2 more>` The available actions that a rule can apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `configuration: AccessRuleIPConfiguration | IPV6Configuration | AccessRuleCIDRConfiguration | 2 more` The rule configuration. - `AccessRuleIPConfiguration` - `target?: "ip"` The configuration target. You must set the target to `ip` when specifying an IP address in the rule. - `"ip"` - `value?: string` The IP address to match. This address will be compared to the IP address of incoming requests. - `IPV6Configuration` - `target?: "ip6"` The configuration target. You must set the target to `ip6` when specifying an IPv6 address in the rule. - `"ip6"` - `value?: string` The IPv6 address to match. - `AccessRuleCIDRConfiguration` - `target?: "ip_range"` The configuration target. You must set the target to `ip_range` when specifying an IP address range in the rule. - `"ip_range"` - `value?: string` The IP address range to match. You can only use prefix lengths `/16` and `/24` for IPv4 ranges, and prefix lengths `/32`, `/48`, and `/64` for IPv6 ranges. - `ASNConfiguration` - `target?: "asn"` The configuration target. You must set the target to `asn` when specifying an Autonomous System Number (ASN) in the rule. - `"asn"` - `value?: string` The AS number to match. - `CountryConfiguration` - `target?: "country"` The configuration target. You must set the target to `country` when specifying a country code in the rule. - `"country"` - `value?: string` The two-letter ISO-3166-1 alpha-2 code to match. For more information, refer to [IP Access rules: Parameters](https://developers.cloudflare.com/waf/tools/ip-access-rules/parameters/#country). - `mode: "block" | "challenge" | "whitelist" | 2 more` The action to apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `created_on?: string` The timestamp of when the rule was created. - `modified_on?: string` The timestamp of when the rule was last modified. - `notes?: string` An informative summary of the rule, typically used as a reminder or explanation. - `scope?: Scope` All zones owned by the user will have the rule applied. - `id?: string` Defines an identifier. - `email?: string` The contact email address of the user. - `type?: "user" | "organization"` Defines the scope of the rule. - `"user"` - `"organization"` ### Access Rule Create Response - `AccessRuleCreateResponse` - `id: string` The unique identifier of the IP Access rule. - `allowed_modes: Array<"block" | "challenge" | "whitelist" | 2 more>` The available actions that a rule can apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `configuration: AccessRuleIPConfiguration | IPV6Configuration | AccessRuleCIDRConfiguration | 2 more` The rule configuration. - `AccessRuleIPConfiguration` - `target?: "ip"` The configuration target. You must set the target to `ip` when specifying an IP address in the rule. - `"ip"` - `value?: string` The IP address to match. This address will be compared to the IP address of incoming requests. - `IPV6Configuration` - `target?: "ip6"` The configuration target. You must set the target to `ip6` when specifying an IPv6 address in the rule. - `"ip6"` - `value?: string` The IPv6 address to match. - `AccessRuleCIDRConfiguration` - `target?: "ip_range"` The configuration target. You must set the target to `ip_range` when specifying an IP address range in the rule. - `"ip_range"` - `value?: string` The IP address range to match. You can only use prefix lengths `/16` and `/24` for IPv4 ranges, and prefix lengths `/32`, `/48`, and `/64` for IPv6 ranges. - `ASNConfiguration` - `target?: "asn"` The configuration target. You must set the target to `asn` when specifying an Autonomous System Number (ASN) in the rule. - `"asn"` - `value?: string` The AS number to match. - `CountryConfiguration` - `target?: "country"` The configuration target. You must set the target to `country` when specifying a country code in the rule. - `"country"` - `value?: string` The two-letter ISO-3166-1 alpha-2 code to match. For more information, refer to [IP Access rules: Parameters](https://developers.cloudflare.com/waf/tools/ip-access-rules/parameters/#country). - `mode: "block" | "challenge" | "whitelist" | 2 more` The action to apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `created_on?: string` The timestamp of when the rule was created. - `modified_on?: string` The timestamp of when the rule was last modified. - `notes?: string` An informative summary of the rule, typically used as a reminder or explanation. - `scope?: Scope` All zones owned by the user will have the rule applied. - `id?: string` Defines an identifier. - `email?: string` The contact email address of the user. - `type?: "user" | "organization"` Defines the scope of the rule. - `"user"` - `"organization"` ### Access Rule Edit Response - `AccessRuleEditResponse` - `id: string` The unique identifier of the IP Access rule. - `allowed_modes: Array<"block" | "challenge" | "whitelist" | 2 more>` The available actions that a rule can apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `configuration: AccessRuleIPConfiguration | IPV6Configuration | AccessRuleCIDRConfiguration | 2 more` The rule configuration. - `AccessRuleIPConfiguration` - `target?: "ip"` The configuration target. You must set the target to `ip` when specifying an IP address in the rule. - `"ip"` - `value?: string` The IP address to match. This address will be compared to the IP address of incoming requests. - `IPV6Configuration` - `target?: "ip6"` The configuration target. You must set the target to `ip6` when specifying an IPv6 address in the rule. - `"ip6"` - `value?: string` The IPv6 address to match. - `AccessRuleCIDRConfiguration` - `target?: "ip_range"` The configuration target. You must set the target to `ip_range` when specifying an IP address range in the rule. - `"ip_range"` - `value?: string` The IP address range to match. You can only use prefix lengths `/16` and `/24` for IPv4 ranges, and prefix lengths `/32`, `/48`, and `/64` for IPv6 ranges. - `ASNConfiguration` - `target?: "asn"` The configuration target. You must set the target to `asn` when specifying an Autonomous System Number (ASN) in the rule. - `"asn"` - `value?: string` The AS number to match. - `CountryConfiguration` - `target?: "country"` The configuration target. You must set the target to `country` when specifying a country code in the rule. - `"country"` - `value?: string` The two-letter ISO-3166-1 alpha-2 code to match. For more information, refer to [IP Access rules: Parameters](https://developers.cloudflare.com/waf/tools/ip-access-rules/parameters/#country). - `mode: "block" | "challenge" | "whitelist" | 2 more` The action to apply to a matched request. - `"block"` - `"challenge"` - `"whitelist"` - `"js_challenge"` - `"managed_challenge"` - `created_on?: string` The timestamp of when the rule was created. - `modified_on?: string` The timestamp of when the rule was last modified. - `notes?: string` An informative summary of the rule, typically used as a reminder or explanation. - `scope?: Scope` All zones owned by the user will have the rule applied. - `id?: string` Defines an identifier. - `email?: string` The contact email address of the user. - `type?: "user" | "organization"` Defines the scope of the rule. - `"user"` - `"organization"` ### Access Rule Delete Response - `AccessRuleDeleteResponse` - `id: string` Defines an identifier.